<%@ Page Language="VB" ResponseEncoding="iso-8859-1" Debug="true" %>
<%@ Register TagPrefix="Rico" TagName="LiveGrid" Src="../../plugins/dotnet/LiveGrid.ascx" %>
<%@ Register TagPrefix="Rico" TagName="Column" Src="../../plugins/dotnet/GridColumn.ascx" %>
<%@ Register TagPrefix="Rico" TagName="sqlCompatibilty" Src="../../plugins/dotnet/sqlCompatibilty.ascx" %>
<%@ Register TagPrefix="My" TagName="LoadRicoClient" Src="LoadRicoClient.ascx" %>
<%@ Register TagPrefix="My" TagName="dbLib" Src="dbConnect.ascx" %>
<My:dbLib id='app' runat='server' />

<script runat="server">

Sub Page_Load(Sender As object, e As EventArgs)
  Session.Timeout=60
  dim arEmpSql as string() = {"%alias%LastName","', '","%alias%FirstName"}
  dim oSqlCompat=new sqlCompatibilty(app.dbDialect)
  emp.getColumnByName("ReportsTo").SelectSql="select EmployeeID," & oSqlCompat.Concat(arEmpSql,false) & " from employees order by LastName,FirstName" 
  app.OpenGridForm(emp)
End Sub

Protected Overrides Sub Render(writer as HTMLTextWriter)
  select case emp.action
    case "table": MyBase.Render(writer)
    case "ins":   emp.InsertRecord(writer)
    case "upd":   emp.UpdateRecord(writer)
    case "del":   emp.DeleteRecord(writer)
  end select
End Sub

</script>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title>Rico LiveGrid-Northwind Employees</title>

<My:LoadRicoClient id='initlibs' runat='server' modules='Calendar' />
<link href="../demo.css" type="text/css" rel="stylesheet" />

<script type='text/javascript'>

// ricoLiveGridForms will call emp_FormInit right before form initialization.

function emp_FormInit() {
  var cal=new Rico.CalendarControl("Cal");
  Rico.EditControls.register(cal, Rico.imgDir+'calarrow.png');
}
</script>

<style type="text/css">
div.ricoLG_cell {
  white-space:nowrap;
}
</style>
</head>
<body>

<div id='explanation'>
Base Library: 
<script type='text/javascript'>
document.write(Rico.Lib+' '+Rico.LibVersion);
</script>
<hr>The data on this grid can be edited using pop-up forms. 
Just click on a grid cell and then select Edit, Delete, or Add from the pop-up menu. 
The Add and Edit forms are automatically generated by LiveGrid. 
Notice on the Edit form how the Rico Calendar is used to change dates. 
Updates are disabled on the database, so you will get an error message if you try to save.
<a href='ricoQuery.aspx?id=ex2x&offset=0&page_size=10&get_total=true'>View the AJAX response (XML)</a>.
</div>
<p><strong>Employees Table</strong></p>

<Rico:LiveGrid runat='server' id='emp' TableName='employees' formView='true' DefaultSort='t.LastName,t.FirstName' menuEvent='click' frozenColumns='2' highlightElem='cursorRow'>
<GridColumns>
  <Rico:Column runat='server' ColName='EmployeeID' heading='Emp#'        width='60'  EntryType='B' ColData='<auto>' />
  <Rico:Column runat='server' ColName='LastName'   heading='Last Name'   width='100' EntryType='B' />
  <Rico:Column runat='server' ColName='FirstName'  heading='First Name'  width='100' EntryType='B' />
  <Rico:Column runat='server' ColName='Title'      heading='Title'       width='120' EntryType='T' />
  <Rico:Column runat='server' ColName='TitleOfCourtesy' heading='Title (Courtesy)' width='90' EntryType='T' />
  <Rico:Column runat='server' ColName='BirthDate'  heading='Birth Date'  width='100' datatype='date' EntryType='D' SelectCtl='Cal' />
  <Rico:Column runat='server' ColName='HireDate'   heading='Hire Date'   width='100' datatype='date' EntryType='D' ColData='Today' SelectCtl='Cal' />
  <Rico:Column runat='server' ColName='Address'    heading='Address'     width='100' EntryType='T' />
  <Rico:Column runat='server' ColName='City'       heading='City'        width='100' EntryType='T' />
  <Rico:Column runat='server' ColName='Region'     heading='Region'      width='100' EntryType='N' />
  <Rico:Column runat='server' ColName='PostalCode' heading='Postal Code' width='100' EntryType='T' />
  <Rico:Column runat='server' ColName='Country'    heading='Country'     width='100' EntryType='N' />
  <Rico:Column runat='server' ColName='HomePhone'  heading='Home Phone'  width='100' EntryType='T' />
  <Rico:Column runat='server' ColName='Extension'  heading='Extension'   width='100' EntryType='T' />
  <Rico:Column runat='server' ColName='ReportsTo'  heading='ReportsTo'   width='100' EntryType='SL' />
</GridColumns>
</Rico:LiveGrid>

</body>
</html>
